#Declaration of all methods 

proc emptyGarbage { } {
	global garbage
	foreach tempfile $garbage {
		file delete $tempfile
		}
}

proc myExit { } {
emptyGarbage
exit
}

proc drawBeamCenter {can x y} {
	$can create line "[expr $x - 5] [expr $y - 5] [expr $x + 5] \
	                               [expr $y + 5]" -fill red -width 2
	$can create line "[expr $x + 5] [expr $y - 5] [expr $x - 5] \
	                               [expr $y + 5]" -fill red -width 2
}

#From now on the following methods are only used within the version of the viewer
#used within xia

proc createXIAVersion { myargs } {
global garbage
global XIAparam
	set myind [lsearch $myargs "-file"]
	if {$myind != -1} {
		set currentimage [new_DiffractionImage [lindex $myargs [expr $myind + 1]]]
	} else {
		puts "no image file given in input!"
		exit
	}
	
	set maxsize [expr [winfo screenwidth .] - 20]
	if {[expr [winfo screenheight .] - 100] < $maxsize } {
		set maxsize [expr [winfo screenheight .] - 100]
		}

	frame .top
	frame .bottom
	canvas .top.diffcanvas -xscrollcommand [list .top.xscroll set] \
				           -yscrollcommand [list .top.yscroll set]			   
	scrollbar .top.xscroll -orient horizontal -command [list .top.diffcanvas xview]
	scrollbar .top.yscroll -orient vertical -command [list .top.diffcanvas yview]
	grid .top.diffcanvas .top.yscroll -sticky news
	grid .top.xscroll -sticky ew
	grid rowconfigure .top 0 -weight 1
	grid columnconfigure .top 0 -weight 1
	pack .top -side top -fill both -expand true
	button .bottom.polymask -text "Draw Polygonal Mask" -padx 10 \
			-command "setDrawMode poly"
	button .bottom.circlemask -text "Draw Circular Mask" -padx 10 \
			-command "setDrawMode  circle"
	grid .bottom.polymask .bottom.circlemask
	pack .bottom -side bottom -fill none
	
	set myind [lsearch $myargs "-zoom"]
	if {$myind != -1} {
		set myzoom [expr [lindex $myargs [expr $myind + 1]] / 100.0]
		if { [expr [$currentimage getWidth] * $myzoom] < $maxsize} {
			.top.diffcanvas configure -height [expr [$currentimage getHeight] * $myzoom] \
			                          -width [expr [$currentimage getWidth] * $myzoom]
		} else {
			.top.diffcanvas configure -height 600 -width 600
		}
	} else {
		foreach whichzoom {0.25 0.5 1.0} {
			set size [expr [$currentimage getWidth] * $whichzoom]
			if {$size < $maxsize} {
				set myzoom $whichzoom
			}
		}
		.top.diffcanvas configure -height [expr [$currentimage getHeight] * $myzoom] \
								  -width [expr [$currentimage getWidth] * $myzoom]
	}
	
	set XIAparam(ZOOM) $myzoom
	set w [$currentimage getWidth]
	set h [$currentimage getHeight]
	set w [expr $w * $myzoom]
	set h [expr $h * $myzoom]
	
	.top configure -width $w -height $h
	.bottom configure -width $w -height 30
	set myCimage [$currentimage getImage $myzoom 0 0 [$currentimage getWidth] \
	                                    [$currentimage getHeight]]
	.top.diffcanvas delete tclimage
	set tclimage [image create photo tclimage -format ppm -file $myCimage]
	set XIAparam(IMAGE) tclimage
	.top.diffcanvas create image [expr $w / 2] [expr $h / 2] -image tclimage
	.top.diffcanvas configure -scrollregion "0 0 $w $h"
	update idle
	
	set myind [lsearch $myargs "-plotbeam"]
	if {$myind != -1} {
		if {[string first "-" [lindex $myargs [expr $myind + 1]]] != -1 } {
			set mmbeam "[$currentimage getBeamX] [$currentimage getBeamY]"
		} else {
			set mmbeam "[lindex $myargs [expr $myind + 1]] \
			            [lindex $myargs [expr $myind + 2]]"
		}
		set floatx [expr [lindex $mmbeam 0] / [$currentimage getPixelX]]
		set floaty [expr [lindex $mmbeam 1] / [$currentimage getPixelY]]
		set floatx [expr round($floatx) * $myzoom]
		set floaty [expr round($floaty) * $myzoom]
		set XIAparam(PIXELBEAM) "$floatx $floaty"
		drawBeamCenter .top.diffcanvas $floatx $floaty
	} else {
		set mmbeam "-1 -1"
	}
	
	if {[lsearch $myargs "-automask"] != -1} {
			set pxbeam "[expr [lindex $mmbeam 0] / [$currentimage getPixelX]] \
				    [expr [lindex $mmbeam 1] / [$currentimage getPixelY]]"
			set pxbeam "[expr round([lindex $pxbeam 0])] \
			            [expr round([lindex $pxbeam 1])]"
			set moreargs [$currentimage autoMask [lindex $pxbeam 0] \
			                                     [lindex $pxbeam 1] ]
			puts "$moreargs\n"
			foreach arg $moreargs {
				lappend myargs $arg
			}
		}
	
	while {[lsearch $myargs "-polymask"] != -1} {
		set myind [expr [lsearch $myargs "-polymask"] + 1]
		while {[string first "-" [lindex $myargs $myind]] == -1 && \
		        $myind != [llength $myargs]} {
			incr myind
		}
		set coordinates [lrange $myargs [expr [lsearch $myargs "-polymask"] + 1] \
		                        [expr $myind - 1]]
		set temp {}
		foreach coord $coordinates {
			lappend temp [expr $coord * $myzoom]
		}
		lappend XIAparam(POLY) "$temp"
		drawPolyMask .top.diffcanvas $temp
		set myargs [lreplace $myargs [lsearch $myargs "-polymask"] [lsearch $myargs "-polymask"] ""]
	}
	
	if {[lsearch $myargs "-circlemask"] != -1} {
		set myind [expr [lsearch $myargs "-circlemask"] + 1]
		set centerx [lindex $myargs [expr $myind]]
		set centery [lindex $myargs [expr $myind + 1]]
		set centerx [expr $centerx * $myzoom]
		set centery [expr $centery * $myzoom]
		set center "$centerx $centery"
		set radius [lindex $myargs [expr $myind + 2]]
		set radius [expr $radius * $myzoom]
		set XIAparam(CIRCLE) "$centerx $centery $radius"
		drawCircleMask .top.diffcanvas $center $radius
	}
	bind .top.diffcanvas <Button-1> "handleLeftClick %x %y; refreshDisplay"
	bind .top.diffcanvas <Button-3> "handleRightClick %x %y; refreshDisplay"
	bind .top.diffcanvas <Motion> "handleMouseMotion %x %y; refreshDisplay"
	bind .top.diffcanvas <Key-Escape> "handleEscapeKey; refreshDisplay"
	lappend garbage $myCimage
}
	
proc setDrawMode {mode} {
global XIAparam

	set XIAparam(MODE) "$mode"
	.bottom.polymask configure -state disabled
	.bottom.circlemask configure -state disabled
}

proc handleLeftClick {xcoord ycoord} {
global XIAparam
	
	set xcoord [.top.diffcanvas canvasx $xcoord]
	set ycoord [.top.diffcanvas canvasy $ycoord]
	if {$XIAparam(MODE) == "poly"} {
		lappend XIAparam(POLY) $xcoord
		lappend XIAparam(POLY) $ycoord
	} elseif {$XIAparam(MODE) == "circle"} {
		set XIAparam(CIRCLE) "$xcoord $ycoord"
		set XIAparam(MODE) "setradius"
	}  elseif {$XIAparam(MODE) == "setradius"} {
		set centrex [lindex $XIAparam(CIRCLE) 0]
		set centrey [lindex $XIAparam(CIRCLE) 1]
		set dist [expr [expr $centrex - $xcoord] * [expr $centrex - $xcoord] ]
		set dist [expr $dist + [expr $centrey - $ycoord] * [expr $centrey - $ycoord] ]
		set dist [expr sqrt($dist)]
		lappend XIAparam(CIRCLE) $dist
		set XIAparam(MODE) "none"
		set realcoords {}
		foreach value $XIAparam(CIRCLE) {
		lappend realcoords [expr $value / $XIAparam(ZOOM)]
		}
		puts "-circlemask $realcoords"
		.bottom.polymask configure -state active
		.bottom.circlemask configure -state active
	} elseif {[lsearch [array names XIAparam] "MMBEAM"] !=-1} {
		set distx [expr abs([expr $xcoord - [lindex $XIAparam(PIXELBEAM) 0]])]
		set disty [expr abs([expr $ycoord - [lindex $XIAparam(PIXELBEAM) 1]])]
		if {$distx < 5 && $disty <5} {
			puts "beam centre : [lindex $XIAparam(MMBEAM) 0] [lindex $XIAparam(MMBEAM) 1]"
		}
	}
}

proc handleRightClick {xcoord ycoord} {
global XIAparam

	set xcoord [.top.diffcanvas canvasx $xcoord]
	set ycoord [.top.diffcanvas canvasy $ycoord]
	if {$XIAparam(MODE) == "poly"} {
		if {[llength $XIAparam(POLY)] == 2} {
		bgerror "Sorry you need at least 3 points to make a polygone"
		} else {
		lappend XIAparam(POLY) $xcoord
		lappend XIAparam(POLY) $ycoord
		set XIAparam(MODE) "none"
		set realcoords {}
		foreach value $XIAparam(POLY) {
		lappend realcoords [expr $value / $XIAparam(ZOOM)]
		}
		puts "-polymask $realcoords"
		.bottom.polymask configure -state active
		.bottom.circlemask configure -state active
		}
	} 
}

proc handleMouseMotion {xcoord ycoord} {
global XIAparam

	set xcoord [.top.diffcanvas canvasx $xcoord]
	set ycoord [.top.diffcanvas canvasy $ycoord]
	if {$XIAparam(MODE) == "poly" || $XIAparam(MODE) == "circle"} {
		set XIAparam(TEMPDRAW) "$xcoord $ycoord"
	} elseif {$XIAparam(MODE) == "setradius"} {
		set centrex [lindex $XIAparam(CIRCLE) 0]
		set centrey [lindex $XIAparam(CIRCLE) 1]
		set dist [expr [expr $centrex - $xcoord] * [expr $centrex - $xcoord] ]
		set dist [expr $dist + [expr $centrey - $ycoord] * [expr $centrey - $ycoord] ]
		set dist [expr sqrt($dist)]
		set XIAparam(TEMPDRAW) "$dist"
	}
}

proc handleEscapeKey {} {
global XIAparam
}

proc refreshDisplay {} {
global  XIAparam

	.top.diffcanvas delete all
	set w [image width $XIAparam(IMAGE)]
	set h [image height $XIAparam(IMAGE)]
	.top.diffcanvas create image [expr $w / 2] [expr $h / 2] -image tclimage
	if {[lsearch [array names XIAparam] "POLY"] !=-1 } {
		set coordinates $XIAparam(POLY)
		if {$XIAparam(MODE) == "poly" && \
		    [lsearch [array names XIAparam] "TEMPDRAW"] !=-1} {
			set coordinates [concat $coordinates $XIAparam(TEMPDRAW)]
			if {[llength $coordinates] > 2} {
				drawPolyMask .top.diffcanvas $coordinates
			} elseif {[llength $coordinates] == 2} {
				drawMaskVertex .top.diffcanvas $coordinates
			}
		} else {
			foreach setofcoord $coordinates {
				drawPolyMask .top.diffcanvas $setofcoord
			}
		}
		
	} else {
		if {$XIAparam(MODE) == "poly" && \
			[lsearch [array names XIAparam] "TEMPDRAW"] !=-1} {
			drawMaskVertex .top.diffcanvas $XIAparam(TEMPDRAW)
			}
	}
	if {[lsearch [array names XIAparam] "CIRCLE"] !=-1 } {
		set coordinates $XIAparam(CIRCLE)
		if {$XIAparam(MODE) == "setradius" && \
		    [lsearch [array names XIAparam] "TEMPDRAW"] !=-1} {
			set coordinates [concat $coordinates $XIAparam(TEMPDRAW)]
		}
		if {[llength $coordinates] == 3} {
			set centre "[lindex $coordinates 0] [lindex $coordinates 1]"
			drawCircleMask .top.diffcanvas $centre [lindex $coordinates 2]
		} elseif {[llength $coordinates] == 2} {
			drawMaskVertex .top.diffcanvas $coordinates
		}	
	} else {
		if {$XIAparam(MODE) == "circle" && \
			[lsearch [array names XIAparam] "TEMPDRAW"] !=-1} {
			drawMaskVertex .top.diffcanvas $XIAparam(TEMPDRAW)
			}
	}
	if {[lsearch [array names XIAparam] "PIXELBEAM"] !=-1 } {
		if {[llength $XIAparam(PIXELBEAM)] != 0} {
			drawBeamCenter .top.diffcanvas [lindex $XIAparam(PIXELBEAM) 0] \
										   [lindex $XIAparam(PIXELBEAM) 1]
		}
	}

}
proc drawMaskVertex {can coord} {

	set xcoord [lindex $coord 0]
	set ycoord [lindex $coord 1]
	set coordlist "[expr $xcoord - 1] [expr $ycoord -1] [expr $xcoord +1] \
	               [expr $ycoord + 1]"
	$can create rectangle $coordlist -outline green \
								     -width 2 
}


proc drawPolyMask {can coordlist} {
	if {[llength $coordlist] > 4} {
		$can create poly $coordlist -fill green -outline green \
									  -width 2 -stipple gray12
	} else {
		$can create line $coordlist -fill green \
									-width 2
	}
	for {set i 0} {$i< [llength $coordlist]} {set i [expr $i +2]} {
	drawMaskVertex $can "[lindex $coordlist $i] [lindex $coordlist [expr $i + 1]]" 
	}
}

proc drawCircleMask {can center radius} {
global tcl_platform
    set bbox "[expr [lindex $center 0] - $radius] [expr [lindex $center 1] - $radius] \
	          [expr [lindex $center 0] + $radius] [expr [lindex $center 1] + $radius]"
	if {$tcl_platform(platform) == "windows"} {
 	$can create oval $bbox -outline green -width 2
	} else {
 	$can create oval $bbox -outline green -fill green -stipple gray12 -width 2
	}
	drawMaskVertex .top.diffcanvas "[lindex $center 0] [lindex $center 1]"
}

#------------------------------------------------------------------------------

#Now starting the program

if {$tcl_platform(platform) == "windows"} {
	load DiffractionImage.dll
} elseif {$tcl_platform(os) == "Darwin"} {
	load libDiffractionImage.dylib
} else {
	load libDiffractionImage.so
}
	
set garbage {}
set XIAparam(MODE) "none"
set XIAparam(ZOOM) 0.5
createXIAVersion $argv

wm title . "XIA Diffraction Image viewer"
wm deiconify .
wm protocol . WM_DELETE_WINDOW "myExit"
